/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim: set ts=8 sts=2 et sw=2 tw=80: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_Components_h
#define mozilla_Components_h

#include "nsCOMPtr.h"

struct nsID;

#define NS_IMPL_COMPONENT_FACTORY(iface) \
  template <>                            \
  already_AddRefed<nsISupports> mozCreateComponent<iface>()

template <typename T>
already_AddRefed<nsISupports> mozCreateComponent();

namespace mozilla {
namespace xpcom {

enum class ModuleID : uint16_t {
  Anonymous375,
  Anonymous004,
  Anonymous213,
  Anonymous448,
  AddonContentPolicy,
  Anonymous428,
  Anonymous281,
  Anonymous310,
  CacheStorage,
  Anonymous393,
  Anonymous104,
  Anonymous195,
  Anonymous007,
  Anonymous203,
  Anonymous164,
  Anonymous165,
  Anonymous366,
  Anonymous287,
  Anonymous306,
  Anonymous279,
  Anonymous031,
  Anonymous421,
  Anonymous145,
  Anonymous429,
  Anonymous170,
  Anonymous231,
  Anonymous385,
  Anonymous210,
  Anonymous150,
  Anonymous447,
  Anonymous238,
  Anonymous452,
  Anonymous340,
  Anonymous131,
  Anonymous176,
  Anonymous288,
  Anonymous009,
  Anonymous228,
  Anonymous045,
  Anonymous278,
  Anonymous208,
  Anonymous392,
  Anonymous308,
  Anonymous353,
  Anonymous316,
  Anonymous318,
  Anonymous059,
  URIFixup,
  Anonymous372,
  Anonymous154,
  Anonymous038,
  Anonymous301,
  Anonymous396,
  Directory,
  Anonymous324,
  Anonymous109,
  Anonymous362,
  Anonymous127,
  Anonymous075,
  Anonymous089,
  UrlClassifierDB,
  Anonymous273,
  Anonymous183,
  Anonymous422,
  Anonymous443,
  Anonymous040,
  Anonymous305,
  UrlClassifierPrefixSet,
  UUIDGenerator,
  Anonymous367,
  Anonymous391,
  Anonymous256,
  Anonymous275,
  Anonymous457,
  Anonymous077,
  Anonymous173,
  Anonymous215,
  Anonymous087,
  Anonymous251,
  Anonymous166,
  Anonymous107,
  Anonymous304,
  Anonymous329,
  Anonymous125,
  Anonymous380,
  Anonymous319,
  Anonymous390,
  Anonymous399,
  Anonymous194,
  Anonymous272,
  Anonymous048,
  Anonymous003,
  Anonymous135,
  URILoader,
  Anonymous032,
  Anonymous106,
  Anonymous147,
  Anonymous057,
  Anonymous365,
  Anonymous235,
  Anonymous349,
  Anonymous013,
  Anonymous216,
  Anonymous328,
  Anonymous240,
  Anonymous327,
  Anonymous352,
  Anonymous290,
  Anonymous119,
  Anonymous151,
  Anonymous158,
  GfxInfo,
  Anonymous271,
  Anonymous015,
  Anonymous133,
  AppStartup,
  Anonymous039,
  ApplicationReputation,
  Anonymous113,
  Anonymous233,
  Anonymous086,
  Anonymous026,
  Anonymous214,
  Anonymous368,
  Anonymous455,
  Anonymous193,
  Anonymous357,
  Anonymous264,
  Anonymous334,
  Anonymous103,
  Anonymous226,
  Anonymous212,
  Anonymous143,
  AsyncShutdown,
  Anonymous434,
  Anonymous370,
  Anonymous241,
  Anonymous417,
  Anonymous177,
  Anonymous265,
  Anonymous394,
  DownloadPlatform,
  Anonymous153,
  Anonymous157,
  Anonymous302,
  Anonymous407,
  Anonymous377,
  Anonymous142,
  Anonymous187,
  Anonymous083,
  Anonymous123,
  Anonymous335,
  Anonymous085,
  Anonymous268,
  Anonymous023,
  Anonymous070,
  Anonymous018,
  Anonymous196,
  Anonymous382,
  Anonymous371,
  Anonymous024,
  Anonymous098,
  Anonymous435,
  Anonymous126,
  Anonymous140,
  Anonymous383,
  Anonymous072,
  Anonymous303,
  Anonymous449,
  Anonymous074,
  Anonymous117,
  Anonymous398,
  Anonymous299,
  Anonymous071,
  Anonymous111,
  Anonymous285,
  Anonymous343,
  Anonymous079,
  Anonymous436,
  Anonymous388,
  Anonymous247,
  Anonymous178,
  Anonymous270,
  Anonymous283,
  Anonymous129,
  Anonymous426,
  Anonymous259,
  Anonymous190,
  Anonymous058,
  Anonymous294,
  Anonymous034,
  Anonymous297,
  Anonymous101,
  Anonymous333,
  Anonymous044,
  Anonymous184,
  Anonymous110,
  Anonymous021,
  Anonymous073,
  Anonymous312,
  Anonymous369,
  Anonymous201,
  Anonymous432,
  Anonymous442,
  Anonymous298,
  Anonymous081,
  Anonymous168,
  Anonymous376,
  Anonymous364,
  Anonymous041,
  Anonymous161,
  Anonymous022,
  Anonymous094,
  Anonymous197,
  Anonymous280,
  Anonymous347,
  Anonymous065,
  Anonymous257,
  StringBundle,
  Anonymous179,
  Anonymous339,
  Anonymous236,
  Anonymous199,
  Anonymous050,
  Anonymous445,
  Anonymous415,
  Anonymous260,
  Anonymous277,
  Anonymous311,
  Anonymous229,
  Anonymous037,
  Anonymous175,
  Anonymous105,
  Anonymous336,
  Anonymous091,
  Anonymous291,
  Anonymous052,
  Anonymous378,
  Anonymous254,
  Anonymous189,
  Anonymous069,
  Anonymous152,
  Anonymous450,
  Anonymous293,
  Anonymous033,
  Anonymous374,
  Anonymous292,
  Anonymous130,
  Anonymous325,
  Anonymous006,
  Anonymous230,
  Anonymous001,
  Anonymous221,
  Anonymous379,
  Anonymous425,
  Anonymous401,
  Anonymous323,
  Anonymous205,
  Anonymous095,
  Anonymous137,
  Anonymous453,
  Anonymous234,
  Anonymous036,
  Anonymous451,
  Anonymous043,
  Anonymous232,
  NativeFileWatcher,
  Anonymous284,
  Anonymous198,
  Anonymous348,
  PermissionManager,
  Anonymous211,
  Anonymous404,
  Anonymous102,
  Anonymous444,
  Anonymous020,
  Anonymous246,
  Anonymous309,
  Anonymous384,
  Anonymous016,
  Anonymous263,
  Anonymous148,
  Anonymous276,
  Anonymous191,
  Anonymous100,
  Anonymous136,
  Anonymous424,
  Anonymous320,
  Anonymous395,
  Anonymous413,
  StreamTransport,
  Anonymous337,
  Anonymous010,
  Anonymous014,
  Anonymous192,
  Anonymous064,
  Anonymous030,
  Anonymous084,
  Anonymous361,
  Anonymous313,
  Anonymous200,
  Anonymous243,
  Anonymous403,
  Anonymous092,
  Anonymous181,
  Anonymous342,
  Anonymous225,
  Anonymous144,
  Anonymous000,
  Anonymous433,
  Anonymous359,
  TypeAheadFind,
  Anonymous295,
  Anonymous239,
  Anonymous155,
  UrlClassifierStreamUpdater,
  Anonymous255,
  Anonymous051,
  Anonymous099,
  Prefetch,
  Anonymous269,
  Anonymous355,
  Anonymous360,
  Anonymous406,
  Anonymous061,
  Anonymous186,
  Anonymous237,
  Anonymous146,
  Anonymous068,
  Anonymous389,
  IO,
  Anonymous055,
  Anonymous252,
  Anonymous160,
  Anonymous156,
  Anonymous418,
  Anonymous138,
  Anonymous266,
  Anonymous005,
  UrlClassifierUtils,
  Anonymous248,
  HttpActivityDistributor,
  Anonymous346,
  Anonymous169,
  Anonymous405,
  Anonymous356,
  Anonymous322,
  Anonymous172,
  Anonymous088,
  Anonymous116,
  Anonymous049,
  Anonymous167,
  Anonymous060,
  Anonymous180,
  Anonymous400,
  Anonymous440,
  Anonymous053,
  Anonymous042,
  Anonymous209,
  Anonymous028,
  Anonymous332,
  Alerts,
  Anonymous217,
  Anonymous224,
  Anonymous446,
  Anonymous054,
  Anonymous441,
  Anonymous132,
  Anonymous456,
  Anonymous242,
  ThirdPartyUtil,
  Anonymous338,
  Anonymous162,
  Anonymous112,
  Anonymous120,
  Anonymous387,
  Anonymous067,
  Anonymous282,
  Anonymous082,
  Anonymous307,
  Anonymous227,
  Anonymous035,
  Anonymous253,
  Anonymous261,
  Anonymous218,
  Anonymous029,
  Anonymous289,
  Anonymous345,
  Anonymous012,
  Anonymous431,
  Anonymous344,
  Anonymous124,
  Anonymous423,
  Anonymous019,
  Anonymous206,
  Anonymous121,
  Anonymous414,
  Anonymous011,
  Anonymous056,
  Anonymous262,
  Anonymous002,
  Anonymous321,
  Anonymous204,
  Anonymous326,
  History,
  Anonymous331,
  Anonymous046,
  Anonymous062,
  Anonymous222,
  Anonymous267,
  Anonymous416,
  Anonymous300,
  SocketTransport,
  Anonymous412,
  Anonymous330,
  ServiceWorkerManager,
  Anonymous438,
  Anonymous439,
  Anonymous115,
  Anonymous223,
  Anonymous244,
  Anonymous078,
  Anonymous427,
  Anonymous114,
  Anonymous076,
  Anonymous047,
  Anonymous314,
  Anonymous171,
  Anonymous027,
  Anonymous341,
  Anonymous182,
  Anonymous174,
  Anonymous122,
  Anonymous096,
  Anonymous108,
  Anonymous128,
  Anonymous350,
  Anonymous017,
  Anonymous358,
  Anonymous419,
  Anonymous397,
  Anonymous090,
  Anonymous093,
  Anonymous386,
  Anonymous381,
  Anonymous363,
  Anonymous219,
  Anonymous025,
  Anonymous315,
  Anonymous220,
  Anonymous354,
  Anonymous080,
  Anonymous250,
  Anonymous258,
  Anonymous063,
  Anonymous317,
  AlertNotification,
  Anonymous149,
  Anonymous454,
  Anonymous420,
  Anonymous408,
  Anonymous430,
  Anonymous118,
  Anonymous437,
  Anonymous066,
  Anonymous139,
  Anonymous373,
  Anonymous207,
  Anonymous134,
  DocLoader,
  Anonymous097,
  FindService,
  Anonymous410,
  Anonymous008,
  Anonymous351,
  Anonymous245,
  Anonymous188,
  LoginReputation,
  Anonymous249,
  ChromeRegistry,
  Anonymous202,
  Anonymous159,
  Anonymous286,
  Anonymous409,
  Anonymous185,
  Anonymous296,
  Anonymous163,
  DBusHandlerApp,
  Anonymous274,
  Anonymous141,
  Anonymous402,
  Anonymous411,
  ExtensionPolicy,

};

class MOZ_STACK_CLASS StaticModuleHelper : public nsCOMPtr_helper {
 public:
  StaticModuleHelper(ModuleID aId, nsresult* aErrorPtr)
      : mId(aId), mErrorPtr(aErrorPtr) {}

 protected:
  nsresult SetResult(nsresult aRv) const {
    if (mErrorPtr) {
      *mErrorPtr = aRv;
    }
    return aRv;
  }

  ModuleID mId;
  nsresult* mErrorPtr;
};

class MOZ_STACK_CLASS GetServiceHelper final : public StaticModuleHelper {
 public:
  using StaticModuleHelper::StaticModuleHelper;

  nsresult NS_FASTCALL operator()(const nsIID& aIID,
                                  void** aResult) const override;
};

class MOZ_STACK_CLASS CreateInstanceHelper final : public StaticModuleHelper {
 public:
  using StaticModuleHelper::StaticModuleHelper;

  nsresult NS_FASTCALL operator()(const nsIID& aIID,
                                  void** aResult) const override;
};

class Components final {
 public:
  static const nsID& GetCID(ModuleID aID);
};

}  // namespace xpcom

namespace components {

namespace AddonContentPolicy {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::AddonContentPolicy);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AddonContentPolicy, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AddonContentPolicy, aRv};
}
}  // namespace AddonContentPolicy

namespace AlertNotification {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::AlertNotification);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AlertNotification, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AlertNotification, aRv};
}
}  // namespace AlertNotification

namespace Alerts {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Alerts);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Alerts, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Alerts, aRv};
}
}  // namespace Alerts

namespace AppStartup {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::AppStartup);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AppStartup, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AppStartup, aRv};
}
}  // namespace AppStartup

namespace ApplicationReputation {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::ApplicationReputation);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ApplicationReputation, aRv};
}
}  // namespace ApplicationReputation

namespace AsyncShutdown {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::AsyncShutdown);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AsyncShutdown, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AsyncShutdown, aRv};
}
}  // namespace AsyncShutdown

namespace CacheStorage {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::CacheStorage);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::CacheStorage, aRv};
}
}  // namespace CacheStorage

namespace ChromeRegistry {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::ChromeRegistry);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ChromeRegistry, aRv};
}
}  // namespace ChromeRegistry

namespace DBusHandlerApp {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::DBusHandlerApp);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DBusHandlerApp, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DBusHandlerApp, aRv};
}
}  // namespace DBusHandlerApp

namespace Directory {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Directory);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Directory, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Directory, aRv};
}
}  // namespace Directory

namespace DocLoader {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::DocLoader);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DocLoader, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DocLoader, aRv};
}
}  // namespace DocLoader

namespace DownloadPlatform {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::DownloadPlatform);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DownloadPlatform, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DownloadPlatform, aRv};
}
}  // namespace DownloadPlatform

namespace ExtensionPolicy {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::ExtensionPolicy);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ExtensionPolicy, aRv};
}
}  // namespace ExtensionPolicy

namespace FindService {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::FindService);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::FindService, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::FindService, aRv};
}
}  // namespace FindService

namespace GfxInfo {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::GfxInfo);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::GfxInfo, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::GfxInfo, aRv};
}
}  // namespace GfxInfo

namespace History {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::History);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::History, aRv};
}
}  // namespace History

namespace HttpActivityDistributor {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::HttpActivityDistributor);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::HttpActivityDistributor, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::HttpActivityDistributor, aRv};
}
}  // namespace HttpActivityDistributor

namespace IO {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::IO);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::IO, aRv};
}
}  // namespace IO

namespace LoginReputation {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::LoginReputation);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::LoginReputation, aRv};
}
}  // namespace LoginReputation

namespace NativeFileWatcher {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::NativeFileWatcher);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::NativeFileWatcher, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::NativeFileWatcher, aRv};
}
}  // namespace NativeFileWatcher

namespace PermissionManager {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::PermissionManager);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::PermissionManager, aRv};
}
}  // namespace PermissionManager

namespace Prefetch {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Prefetch);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Prefetch, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Prefetch, aRv};
}
}  // namespace Prefetch

namespace ServiceWorkerManager {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::ServiceWorkerManager);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ServiceWorkerManager, aRv};
}
}  // namespace ServiceWorkerManager

namespace SocketTransport {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::SocketTransport);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::SocketTransport, aRv};
}
}  // namespace SocketTransport

namespace StreamTransport {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::StreamTransport);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::StreamTransport, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::StreamTransport, aRv};
}
}  // namespace StreamTransport

namespace StringBundle {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::StringBundle);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::StringBundle, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::StringBundle, aRv};
}
}  // namespace StringBundle

namespace ThirdPartyUtil {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::ThirdPartyUtil);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ThirdPartyUtil, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ThirdPartyUtil, aRv};
}
}  // namespace ThirdPartyUtil

namespace TypeAheadFind {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::TypeAheadFind);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::TypeAheadFind, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::TypeAheadFind, aRv};
}
}  // namespace TypeAheadFind

namespace URIFixup {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::URIFixup);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::URIFixup, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::URIFixup, aRv};
}
}  // namespace URIFixup

namespace URILoader {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::URILoader);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::URILoader, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::URILoader, aRv};
}
}  // namespace URILoader

namespace UUIDGenerator {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::UUIDGenerator);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UUIDGenerator, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UUIDGenerator, aRv};
}
}  // namespace UUIDGenerator

namespace UrlClassifierDB {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::UrlClassifierDB);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierDB, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierDB, aRv};
}
}  // namespace UrlClassifierDB

namespace UrlClassifierPrefixSet {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::UrlClassifierPrefixSet);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierPrefixSet, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierPrefixSet, aRv};
}
}  // namespace UrlClassifierPrefixSet

namespace UrlClassifierStreamUpdater {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::UrlClassifierStreamUpdater);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierStreamUpdater, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierStreamUpdater, aRv};
}
}  // namespace UrlClassifierStreamUpdater

namespace UrlClassifierUtils {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::UrlClassifierUtils);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierUtils, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierUtils, aRv};
}
}  // namespace UrlClassifierUtils

}  // namespace components

}  // namespace mozilla

#endif
